
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>


enum {
//    _xinfreq = 20_000_000,
    _xtlfreq = 20_000_000,
    _clkfreq = 200_000_000,
};



static struct test_parms_t {
    uint32_t  p_clk, p_dat, m_align, v_nco, m_se2, m_dat, m_crc;
} testset;


static void  set_params( void )
{
    testset.p_clk = 0x56;
    testset.p_dat = 0x57;
    testset.m_align = 0;
    testset.v_nco = 0;
    testset.m_se2 = 0x58;
    testset.m_dat = 0x59;
    testset.m_crc = 0x60;
}


static void  tester( void )   __attribute__(opt(no-fast-inline-asm))
{
    uint32_t t1,t2,t3,t4,t5,t6,t7;
    void *ptr = &testset;

    __asm volatile {    // "const" enforces XIP, "volatile" enforces Fcache
// retrieve parameter set
		setq	#sizeof(testset) / 4 - 1
		rdlong	rp_clk, ptr    // fast copy to cogRAM

		mov	t1, rp_clk
		mov	t2, rp_dat
		mov	t3, rm_align
		mov	t4, rv_nco
		mov	t5, rm_se2
		mov	t6, rm_dat
		mov	rm_crc, #0x61
		alts	altreg, #0
		mov	t7, 0-0
		ret

altreg		long rm_crc
rp_clk		res 1
rp_dat		res 1
rm_align	res 1
rv_nco		res 1
rm_se2		res 1
rm_dat		res 130
rm_crc		res 1

    }

    printf(" t1 = %08x\n", t1);
    printf(" t2 = %08x\n", t2);
    printf(" t3 = %08x\n", t3);
    printf(" t4 = %08x\n", t4);
    printf(" t5 = %08x\n", t5);
    printf(" t6 = %08x\n", t6);
    printf(" t7 = %08x\n", t7);

}



//===================================================================================

void  main( void )
{
    printf("   clkfreq = %d   clkmode = 0x%x\n", _clockfreq(), _clockmode());
    printf("  Compiled with FlexC v%s\n", __VERSION__);

    _waitms(100);
    set_params();
    tester();
}
